#ifndef __ZEXTENSION__H
#define __ZEXTENSION__H

#include <map>
#include <string>
#include <boost/asio.hpp>
#include <boost/function.hpp>

#include "model.h"

namespace ZRouter {
	//boost::function<bool (boost::asio::io_service &, ZRouter::Model &model)> FP_ExtensionInitializer;
	typedef bool (*FP_ExtensionInitializer)(boost::asio::io_service&, Model&);
	//typedef bool (int) FP_ExtensionInitializer;
	typedef std::map<std::string, FP_ExtensionInitializer> T_ZExtensionMap; 
	class ZExtensionManager {
		public:
			ZExtensionManager();
			static void register_extension(std::string, FP_ExtensionInitializer);
	};
	//extern T_ZExtensionMap extension_init_map;
}
#endif // __ZEXTENSION__H
