#ifndef __I_REQUEST_HANDLER__H
#define __I_REQUEST_HANDLER__H

#include <string>

namespace http {
namespace server {
	struct reply;
	struct request;
}
namespace handlers {


enum e_request_handler_type { NORMAL, PRE_HOOK, POST_HOOK };

class i_request_handler {
	public:
		virtual const std::string ns_prefix() = 0;
		virtual const e_request_handler_type type() = 0;
		virtual const bool can_handle(const server::request& req) = 0;
		virtual void handle(const server::request& req, server::reply& rep) = 0;
	//	virtual void 
};

}
}
#endif // __I_REQUEST_HANDLER__H

