#ifndef __HTTP_JSON_HANDLER__H
#define __HTTP_JSON_HANDLER__H

#include "http/i_request_handler.hpp"
#include "json_spirit/json_spirit.h"
#include "model.h"

namespace ZRouter {

class http_json_handler : public http::handlers::i_request_handler {
	public:
		http_json_handler(Model::Model &p_model);
		virtual const std::string ns_prefix() ;
		virtual const http::handlers::e_request_handler_type type() ;
		virtual const bool can_handle(const http::server::request& req) ;
		virtual void handle(const http::server::request& req, http::server::reply& rep) ;
	//	virtual void 
	protected:
		Model::Model& model;
};

}
#endif // __HTTP_JSON_HANDLER__H

